<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title><?=_MAIN_TITLE?></title>
<link href="style.css" rel="stylesheet" type="text/css">
</head>

<body>
<?php

/*
GoogleNav Alpha 2
Created on August, 12 2005 by Gilles Riout
Modified on August, 25 2005
gigabyte_land@yahoo.fr
This sofware is GPL'd so please inform me if you modify it.
The GPL License can be found on http://www.gnu.org/copyleft/gpl.html

*/

//This function calculates the distance between two GPS locations
//Not used for the moment
function distcalc($loc1_lat, $loc1_lon, $loc2_lat, $loc2_lon, $precision = 5) {
	$lat1 = $loc1_lat * pi()/180;
	$lat2 = $loc2_lat * pi()/180;
	$lon1 = $loc1_lon * pi()/180;
	$lon2 = $loc2_lon * pi()/180;
	$theta = $lon1 - $lon2;
	$rawdistance = sin($lat1) * sin($lat2) + cos($lat1) * cos($lat2) * cos($theta);
	$distance = round(6367.2 * acos($rawdistance), $precision);
	return $distance;
}

function convdec($coord, $discr) {
$coord=$coord/100;
$dec=intval($coord)+($coord-intval($coord))*100/60;
if ($discr=="W" || $discr== "S") {
	$dec=$dec*-1;
	return $dec;
	} else {
	return $dec;
	}
}

//Reading of NMEA sentences. For the moment, only
//GPRMC and GPGGA is read (most common nmea sentences)

function read_nmea($refresh, $unit, $range, $tilt) {
	global $server, $user, $pass, $db;
	set_time_limit(10);
	$fp = fsockopen ("127.0.0.1", 5330, $errno, $errstr, 30);
	if (!$fp) {
	   die ("$errstr ($errno)");
	}
	switch($unit) {
	case "kph": //Knots per hour
		$coeff=1;
		break;	
	case "kmh": //Metric Kilometer per hour
		$coeff=1.852;
		break;
	case "mph": // English Mile per hour
		$coeff=1.1507794 ;	
	break;
	}
	$compteur=0;
	$point=false;
	while (!$point) {
		$string=@fgets($fp, 4096);
		switch (substr($string,0,6)) {
			case "\$GPRMC" :
				list($sentence, $time, $status, $latitude, $NS, $longitude, $EW, $speed, $course, $date, $magvar, $magvarEW)= explode(",", trim($string)); 
				$latd=convdec($latitude, $NS);
				$lond=convdec($longitude, $EW);
				break;
			case "\$GPGGA" :					
				list($sentence, $time, $latitude, $NS, $longitude, $EW, $fix, $nbsat, $HDOP, $altitude,,,,,)= explode(",", trim($string)); 
				$latd=convdec($latitude, $NS);
				$lond=convdec($longitude, $EW);
				break;
			default :
			break;
		}
		$compteur++;

		if ($status=="A" or $fix == 1){
			$point=true;
		}
		if ($compteur==50){
			die(_LOCALIZATION_NOT_DEFINED);
		}
	}
	$link = mysql_connect($server, $user, $pass);
	if (!$link) {
		die(_IMPOSSIBLE_TO_CONNECT . mysql_error());
	}
	mysql_select_db($db, $link);

	$result=mysql_query('select latd, lond from points order by id desc limit 1'); 
	list($latprec, $lonprec)= mysql_fetch_row($result);
	if ((round($latd,4)<>round($latprec,4)) or (round($lond,4)<>round($lonprec,4))){
		//unusefull to store the same point when you don't move, is it?
		$sql="INSERT INTO points 
		(time , latitude , NS , longitude , EW , speed , unit, course , date , altitude, range, tilt, latd , lond ) 
		VALUES (\"$time\", \"$latitude\", \"$NS\", \"$longitude\", \"$EW\", \"".$speed*$coeff."\", \"$unit\", \"$course\", \"$date\", \"$altitude\", $range, $tilt, $latd, $lond 
		);" ;
//		echo $sql;
		$qry = mysql_query($sql, $link); 
	}
echo '
<table width="100%"  border="1">
  <tr>
    <td>'._NB_SAT.'</td>
    <td>'._LATITUDE.'</td>
    <td>'._LONGITUDE.'</td>
    <td>'._SPEED.'</td>
    <td>'._COURSE.'</td>
    <td>'._ALTITUDE.'</td>
  </tr>
  <tr>
    <td>'.round($nbsat,0).'</td>
    <td>'.round($latd,4).'</td>
    <td>'.round($lond,4).'</td>
    <td>'.round($speed*$coeff,0).'</td>
    <td>'.$course.'</td>
    <td>'.$altitude.'</td>
  </tr>
</table>
';
	fclose ($fp);
	mysql_close($link);
}

function clearTrack() {
include ("config.php");
	$link = mysql_connect($server, $user, $pass);
	if (!$link) {
  		 die(_IMPOSSIBLE_TO_CONNECT . mysql_error());
	}
	mysql_select_db($db, $link);
	$sql="DELETE FROM points;" ;
	$qry = mysql_query($sql, $link); 
	$sql="ALTER TABLE points PACK_KEYS =0 CHECKSUM =0 DELAY_KEY_WRITE =0 AUTO_INCREMENT =1;" ;
	$qry = mysql_query($sql, $link); 	
	mysql_close($link);
	
}

error_reporting(E_ERROR | E_WARNING | E_PARSE);
$stop = $_POST['Stop'];
if(!empty($stop)) {
die(_SESSION_TERMINATED);
}
include("init.php");
include("config.php");
include("set_lang.php");
set_lang();
$refresh = trim($_POST['refresh']);
$unit = trim($_POST['unit']);
$range = trim($_POST['range']);
$tilt = trim($_POST['tilt']);
$clear = $_POST['Clear'];

if(!empty($clear)) {
	clearTrack();
	die(_DATABASE_CLEARED);
}


//global $server, $user, $pass, $db, $refresh,$unit;
read_nmea($refresh, $unit, $range, $tilt);
?>
</body>
</html>